<?xml version="1.0" encoding="ASCII"?>

<!-- oks-schema version 2.0 -->


<!DOCTYPE oks-schema [
  <!ELEMENT oks-schema (info, (include)?, (comments)?, (class)+)>
  <!ELEMENT info EMPTY>
  <!ATTLIST info
      name CDATA #REQUIRED
      type CDATA #REQUIRED
      num-of-items CDATA #REQUIRED
      oks-format CDATA #FIXED "schema"
      oks-version CDATA #REQUIRED
      created-by CDATA #REQUIRED
      created-on CDATA #REQUIRED
      creation-time CDATA #REQUIRED
      last-modified-by CDATA #REQUIRED
      last-modified-on CDATA #REQUIRED
      last-modification-time CDATA #REQUIRED
  >
  <!ELEMENT include (file)+>
  <!ELEMENT file EMPTY>
  <!ATTLIST file
      path CDATA #REQUIRED
  >
  <!ELEMENT comments (comment)+>
  <!ELEMENT comment EMPTY>
  <!ATTLIST comment
      creation-time CDATA #REQUIRED
      created-by CDATA #REQUIRED
      created-on CDATA #REQUIRED
      author CDATA #REQUIRED
      text CDATA #REQUIRED
  >
  <!ELEMENT class (superclass | attribute | relationship | method)*>
  <!ATTLIST class
      name CDATA #REQUIRED
      description CDATA ""
      is-abstract (yes|no) "no"
  >
  <!ELEMENT superclass EMPTY>
  <!ATTLIST superclass name CDATA #REQUIRED>
  <!ELEMENT attribute EMPTY>
  <!ATTLIST attribute
      name CDATA #REQUIRED
      description CDATA ""
      type (bool|s8|u8|s16|u16|s32|u32|s64|u64|float|double|date|time|string|uid|enum|class) #REQUIRED
      range CDATA ""
      format (dec|hex|oct) "dec"
      is-multi-value (yes|no) "no"
      multi-value-implementation (list|vector) "list"
      init-value CDATA ""
      is-not-null (yes|no) "no"
  >
  <!ELEMENT relationship EMPTY>
  <!ATTLIST relationship
      name CDATA #REQUIRED
      description CDATA ""
      class-type CDATA #REQUIRED
      low-cc (zero|one) #REQUIRED
      high-cc (one|many) #REQUIRED
      is-composite (yes|no) #REQUIRED
      is-exclusive (yes|no) #REQUIRED
      is-dependent (yes|no) #REQUIRED
      multi-value-implementation (list|vector) "list"
  >
  <!ELEMENT method (method-implementation*)>
  <!ATTLIST method
      name CDATA #REQUIRED
      description CDATA ""
  >
  <!ELEMENT method-implementation EMPTY>
  <!ATTLIST method-implementation
      language CDATA #REQUIRED
      prototype CDATA #REQUIRED
      body CDATA ""
  >
]>

<oks-schema>

<info name="" type="" num-of-items="1" oks-format="schema" oks-version="oks-06-07-01 built &quot;Jun 19 2014&quot;" created-by="gruwe" created-on="lxplus051" creation-time="20040326T093404" last-modified-by="anegri" last-modified-on="lxplus0162.cern.ch" last-modification-time="20140728T085152"/>

<include>
 <file path="daq/schema/df.schema.xml"/>
 <file path="ftk/schema/FTKCommon.schema.xml"/>
</include>

 <class name="ReadoutModule_DataFormatter" description="DataFormatter module">
  <superclass name="ReadoutModule_FTK"/>
  <superclass name="ResourceSetAND"/>
  <attribute name="DryRun" description="Bypass all the IPBUs calls to validate the infrastructure only"  type="bool" init-value="0" is-not-null="yes"/>
  <attribute name="DF_Shelf" description="Shelf that the DF sits in"  type="u32" init-value="0"/>
  <attribute name="DF_Slot" description="Slot that the DF sits in"  type="u32" init-value="0"/>

  <attribute name="Dummy" description="Just a dummy field"  type="bool" init-value="0" is-not-null="yes"/>
  <attribute name="ConfigPath" description="Absolute path of configuration directory" type="string"/>
  <attribute name="IPBus_CF" description="Rel. path of connection file for IPBus" type="string"/>
  <attribute name="IPBus_TCF" description="Rel. path of transceiver connection file for IPBus" type="string"/>
  <attribute name="DatabaseFile" description="Input database file containing LUT and Module list info" type="string"/>
  <attribute name="DF_CF" description="Rel. path of configuration file of DF" type="string"/>
  <attribute name="DF_Global_CF" description="Rel. path of global configuration file of DF" type="string"/>
  <attribute name="DF_System_CF" description="Rel. path of system configuration file of DF" type="string"/>
  <attribute name="DF_DelayFile" description="Rel. path of delay file for DF" type="string"/>
  <attribute name="IM_ModuleListFile" description="Rel. path of module list file" type="string"/>
  <attribute name="DF_MultiShelf_CF" description="Rel. path of multi-shelf config file" type="string"/>
  <attribute name="IM_OTF_Configuration" description="Do on-the-fly configuration for IM" type="bool" init-value="0"/>
  <attribute name="IM_LUT_prefix" description="Prefix for IM LUT inputs" type="string" init-value="0"/>
  <attribute name="IM_PseudoData_prefix" description="Prefix for IM pseudo-data inputs" type="string" init-value="0"/>
  <attribute name="DF_OTF_Configuration" description="Do on-the-fly configuration for DF" type="bool" init-value="0"/>
  <attribute name="DF_validate_OTF" description="Validate on-the-fly configuration for DF" type="bool" init-value="0"/>
  <attribute name="DF_Write_OTF_Configuration" description="Write the config seen by OTF to <DF_CF>.dump" type="bool" init-value="0"/>
  <attribute name="IM_LUTs" description="Rel. path of LUT files of IM" type="string"/>
  <attribute name="IM_PseudoData" description="Rel. path of pseudo data files for IM" type="string"/>  
  <attribute name="IPBus_DID" description="Target of device ID for IPBus" type="string"/>
  <!-- <attribute name="SLINKChannelMask" description="Channel mask for enabling SLINK, SLINK is disabled by default"  type="u32" init-value="0" is-not-null="yes"/> -->
  <attribute name="DF_MaxCyclesWaitedForData" description="DF max cycles it will wait for data"  type="u32" init-value="0x4fff"/>
  <attribute name="DF_use_auto_delay_setting" description="use DF auto delay setting"  type="u32" init-value="1"/>
  <attribute name="doFWCheck" description="Flag to use Firmware Version Checking at Configure"  type="bool" init-value="0" is-not-null="yes"/>
  <attribute name="DF_FwVersion" description="DF FW version which should be loaded"  type="u32" init-value="0x0" />
  <attribute name="IM_FwVersion" description="IM FW version which should be loaded"  type="u32" init-value="0x0"/>
  <attribute name="DF_b0fTimeoutThreshold" description="DF b0f timeout threshold to drop IM lane." type="u32" init-value="0x1fffff"/>
  <attribute name="IM_L1TT_PS_MASK"          description="IM L1TT PreScale Mask"  type="u32" init-value="0x00000000"/>
  <attribute name="IM_L1ID_PS_VALUE"         description="IM L1ID PreScale Value"  type="u32" init-value="0x00000000"/>
  <attribute name="IM_L1ID_PS_MASK"          description="IM L1ID PreScale Mask"  type="u32" init-value="0x00000000"/>
  <attribute name="IM_L1ID_FREEZE_VALUE"     description="IM L1ID Freeze Value"  type="u32" init-value="0x00000000"/>
  <attribute name="IM_L1ID_FREEZE_MASK"      description="IM L1ID Freeze Mask"  type="u32" init-value="0x00000000"/>
  <attribute name="IM_ERR_FREEZE_MASK1"      description="IM Error Freeze Mask1"  type="u32" init-value="0x00000000"/>
  <attribute name="IM_ERR_FREEZE_MASK2"      description="IM Error Freeze Mask2"  type="u32" init-value="0x00000000"/>
  <attribute name="IM_START_L1ID_MASK"       description="IM Sync Start L1ID Mask(was 28bit sync)"  type="u32" init-value="0x00000000"/>
  <attribute name="IM_START_L1ID_VALUE"      description="IM Sync Start L1ID Value"  type="u32" init-value="0x00000000"/>
  <attribute name="IM_RECOVER_CONFIG"        description="IM Recover Config(31:timeout enable, 30:long blocked enable, 29:loophit enable, 15:0 count of timeout)"  type="u32" init-value="0xE0000800"/>
  <attribute name="IM_FILLGAP_CONFIG"        description="IM Fillgap config(31:enable bit, 15:0 limit of fillgap event)"  type="u32" init-value="0x800000FF"/>
  <attribute name="IM_HIT_PER_MODULE_IBL"    description="IM Hit/Module removal for IBL(31:enable bit, 15:0 limit of hit/module)"  type="u32" init-value="0x800000FF"/>
  <attribute name="IM_HIT_PER_MODULE_PIX"    description="IM Hit/Module removal for Pix(31:enable bit, 15:0 limit of hit/module)"  type="u32" init-value="0x800000FF"/>
  <attribute name="IM_HIT_PER_MODULE_SCT"    description="IM Hit/Module removal for SCT(31:enable bit, 15:0 limit of hit/module)"  type="u32" init-value="0x800003FF"/>
  <attribute name="IM_IBL_KENTO_REMOVAL"     description="IM IBL special removal(31:enable bit, 15:0 limit of hit/module)"  type="u32" init-value="0x00000000"/>
  <attribute name="IM_SPECIAL5"              description="IM General used register, ask Masahiro."  type="u32" init-value="0x00000000"/>
  <attribute name="IM_PSEUDO_INPUT_RATE"     description="IM Pseudo data input rate value in kHz, default is 100 [kHz]"  type="u32" init-value="0x00000064"/>
  <attribute name="IM_FREEZE_WAIT_CLK"       description="IM Clk cycle to freeze by error freeze"  type="u32" init-value="0x00000001"/>
  <attribute name="IM_GTP_RESET_WAIT_CLK"    description="DONT CHANNGE!! IM GPT reset procedure, how many clk cycle will down link?(default is 1sec)"  type="u32" init-value="0x003D0900"/>
  <attribute name="IM_XOFF_KEYWORD"          description="IM Keyword(Password) for enabling ch0 xoff, Ask Masahiro"  type="u32" init-value="0x00000000"/>
  <attribute name="IM_XOFF_CONFIG"           description="IM ch0 xoff Config(31:xoff_control, 30:enable bit for auto_disable, 29:enable bit for auto_stop, 28:xoff_disable_word, 15:0 limit of xoff(how many xoff do you send?) )"  type="u32" init-value="0x00000000"/>
  <attribute name="IM_IGNORE_HOLD"           description="IM Enable bit(just 1bit) for ignoering BP from DF"  type="u32" init-value="0x0"/>
  <attribute name="IM_XOFF_MODE"             description="IM Enable bit(just 1bit) for sending xoff to ID"  type="u32" init-value="0x0"/>
  <attribute name="IM_GANGED_PIXEL"          description="IM Enable bit(just 1bit) for enabling Ganged Pixel Treatment"  type="u32" init-value="0x0"/>
  <attribute name="IM_REDUNDANCY"            description="IM Enable bit(just 1bit) for enabling SCT Redundancy Treatment"  type="u32" init-value="0x0"/>
  <attribute name="IM_DUPLICATED_MODULE"     description="IM Enable bit(just 1bit) for enabling duplicated module removal"  type="u32" init-value="0x0"/>
  <attribute name="IM_IS_APPLY_SELECTPS"     description="IM Enable bit(just 1bit) for enabling Select PreScale for L1ID"  type="u32" init-value="0x0"/>
  <attribute name="IM_SLINK_MODE_MASK"       description="Channel mask for enabling SLINK, SLINK is disabled by default"  type="u32" init-value="0x0"/>
  <attribute name="IM_IS_APPLY_REJECTPS"     description="IM Enable bit(just 1bit) for enabling Reject PreScale for L1ID"  type="u32" init-value="0x0"/>
  <attribute name="IM_IS_APPLY_L1TTPS"       description="IM Enable bit(just 1bit) for enabling L1 Trigger Type PreScale"  type="u32" init-value="0x0"/>
  <attribute name="IM_IS_APPLY_TRUNCATION"   description="IM Enable bit(just 1bit) for enabling Auto-Truncation"  type="u32" init-value="0x0"/>
  <attribute name="IM_IS_APPLY_FREEZE"       description="IM Enable bit(just 1bit) for enabling Apply Freeze"  type="u32" init-value="0x0"/>
  <attribute name="IM_IS_APPLY_L1ID_FREEZE"  description="IM Enable bit(just 1bit) for enabling L1ID Freeze"  type="u32" init-value="0x0"/>
  <attribute name="IM_IS_APPLY_DF_FREEZE"    description="IM Enable bit(just 1bit) for enabling DF Freeze"  type="u32" init-value="0x0"/>
  <attribute name="IM_IS_APPLY_ERR_FREEZE"   description="IM Enable bit(just 1bit) for enabling Error Freeze"  type="u32" init-value="0x0"/>
  <attribute name="IM_PSEUDO_DATA_XOFF"      description="IM Enable bit(just 1bit) for enabling Xoff for Pseudo data"  type="u32" init-value="0x0"/>
  <attribute name="IM_PSEUDO_DATA_INITIAL_DELAY" description="IM Enable bit(just 1bit) for enabling Pseudo data initial delay fix"  type="u32" init-value="0x1"/>

  <!-- In the next major DF FW release, b0fTimeoutThreshold will be deprecated and the following three timeout thresholds will be used. -->
  <attribute name="DF_skewTimeoutThresholdMax" description="Maximum timeout threshold to drop IM input lane." type="u32" init-value="0x30000"/> <!-- ~1 ms  -->
  <attribute name="DF_skewTimeoutThresholdMin" description="Minimum timeout threshold to drop IM input lane." type="u32" init-value="0xff"/> <!-- ~1 us  -->
  <attribute name="DF_packetHandlerTimeoutThreshold" description="Timeout threshold for the packet handler to complete a partial received packet." type="u32" init-value="0x4e20"/> <!-- 100 us -->

  <attribute name="usePseudoData" description="Use pseudodata for this run. Default to true." type="bool" init-value="false"/>
  <attribute name="IPBusEmulatorMode" description="uhal IPBus SW emulator mode. (default) 0=no emulator. 1=spy on IPBus packets, forward to DF hardware. 2=no hardware, RC ignores IPBus responses." type="u32" init-value="0"/>
  <attribute name="failOnBadLink" description="A mask to toggle whether RC should fail on a link having bad status. If 0 for a given link, then just print a warning. Default = 0x0 (never fail)" type="u64" init-value="0x0"/>
  <attribute name="DF_enableInputResync" description="Enable/disable resync of input after b0f timeout. (1-enabled, 0-disabled)" type="u32" init-value="0"/>
  <attribute name="DF_IM_freezeMode" description="Control freeze sent to IM condition: (0x2)-only freeze on L1ID out of sync (0x4)-only freeze on b0f timeout (0x8)-only freeze on input packet error (0x10)-only freeze on IM input resync (0x1)-freeze on all conditions." type="u32" init-value="0x0" />
  <attribute name="DF_unknownModuleHeaderWord" description="The word output by IM when a module with unknown ID is observed (this is flagged in the DF monitoring." type="u32" init-value="0x80008fff" />
  <attribute name="DF_moduleWordLimit" description="Number of words to allow at the DF input per module." type="u32" init-value="64" />
  <attribute name="DF_boardId" description="Board ID to or into the common error word." type="u32" init-value="0" />
  <attribute name="numGoodDelayValues" description="The minimum threshold for the number of consecutive good delay values that must be found in the per IM FPGA phase scan." type="u32" init-value="6"/>
  <attribute name="Extras" description="Extra values as strings" type="string" is-multi-value="yes" />


 </class>

</oks-schema>
